tryalgo | data structures for preparing programming competitions | Learning library
kandi X-RAY | tryalgo Summary
kandi X-RAY | tryalgo Summary
Algorithms and data structures for preparing programming competitions: basic and advanced
Support
Quality
Security
License
Reuse
Top functions reviewed by kandi - BETA
- Compute the Kruskal Munkres
- Improve the least squares
- This function improves matching matchinging
- Read a graph from a file
- Read tab delimited tab
- Add an item to the list
- Compute the union of the union rectangle
- Private method to update a node
- Change the diagonal
- Gives the union of all rectangles in the input R
- Generate an eulerian tour
- Reads a formula from a file
- Topological ordering
- Calculates the area of a rectangle
- Parse arithm expression
- Find the index of the rabin - karp matching the substring
- Evaluate an expression
- Calculate the knapsack algorithm
- Construct Tarjan s components
- R Compute the arithmetic expression of x
- Compute the knapsack correlation coefficient
- Compute union intersection of two rectangles
- Solve a Horn SAT formula
- Determines the distance between two nodes
- Perform DINIC flow
- Update the heap
tryalgo Key Features
tryalgo Examples and Code Snippets
Community Discussions
Trending Discussions on tryalgo
QUESTION
I'm trying to understand the algorithm that can be used to calculate the area of the union of a set of axis aligned rectangles.
The solution that I'm following is here : http://tryalgo.org/en/geometry/2016/06/25/union-of-rectangles/
The part I don't understand is :
The segment tree is the right choice for this data structure. It has complexity O(logn) for the update operations and O(1) for the query. We need to augment the segment tree with a score per node, with the following properties.
- every node corresponds to a y-interval being the union of the elementary y-intervals over all the indices in the span of the node.
- if the node value is zero, the score is the sum of the scores of the descendants (or 0 if the node is a leaf).
- if the node value is positive, the score is the length of the y-interval corresponding to the node.
How do we achieve this in O(n log n) ?
My idea was to create a segment tree, and update each range's value as and when we encounter the range(y range as the height of the rectangle) while line sweeping. And then for for each interval(two consecutive elements in the sorted x array, multiple Δx by the total length of the y range active in this interval, by looking at the sum of all elements in the segment tree)
This would still leads us to having max(y) - min(y) elements in the segment tree's base.
Hence, I'm not sure how this is O(n log n) - where n is the number of rectangles.
Would greatly appreciate any help here.
Thanks!
...ANSWER
Answered 2019-Apr-17 at 05:11Let's consider some easy case:
According to your understanding you would create segment tree with 11 - 1 = 10 nodes at base, so something like this:
Notice we have only 9 nodes in base, because first node is for interval [1,2], next one for interval [2,3] and so on
And when you enter some rectangle, you would update it's range based on its y coordinates, so after meeting first one on x=0, your segment tree would look like this:
We would also need to use something called lazy propagation to update active intervals on the tree, so all active intervals would contribute 1 to the sum.
So complexity of your current approach is something like O(K log K) where K = max(y)-min(y)
We can easilly reduce this to O(n log n) where n is number of rectangles.
Notice that only important y coordinates are those that exist, so in this example 1,3,6,11
Also notice that there's at most 2*n such coordinates
So we can map all coordinates to some integers so they fit better in segment tree.
This is known as coordinate compression it can be done with something like this:
- Store all y coordinates in array
- sort array and remove duplicates
- use map or hashMap to map original coordinates to it's position in sorted array
So in our example it would be:
[1,3,6,11]
- no duplicates to remove so array still
[1,3,6,11]
mp[1]=1, mp[3]=2, mp[6]=3, mp[11]=4
So now algorithm stays the same, yet we can use segment tree with only at most 2*n nodes in it's base.
Also we would need to modify our segment tree a little, instead of keeping which y coordinates are on or off we will now keep which intervals of y coordinates are on/off
So we will have nodes for intervals [y0,y1],[y1,y2], ... for all unique sorted values of y.
Also all nodes will contribute y[i]-y[i-1] to the sum (if they are in range and active) instead of one.
So our new segment tree would be something like this:
Community Discussions, Code Snippets contain sources that include Stack Exchange Network
Vulnerabilities
No vulnerabilities reported
Install tryalgo
You can use tryalgo like any standard Python library. You will need to make sure that you have a development environment consisting of a Python distribution including header files, a compiler, pip, and git installed. Make sure that your pip, setuptools, and wheel are up to date. When using pip it is generally recommended to install packages in a virtual environment to avoid changes to the system.
Support
Reuse Trending Solutions
Find, review, and download reusable Libraries, Code Snippets, Cloud APIs from over 650 million Knowledge Items
Find more librariesStay Updated
Subscribe to our newsletter for trending solutions and developer bootcamps
Share this Page